import java.io.ByteArrayInputStream;
import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.net.DatagramPacket;
import java.net.DatagramSocket;
import java.net.SocketException;
import java.util.concurrent.ConcurrentSkipListSet;


import org.ccnx.ccn.CCNHandle;
import org.ccnx.ccn.config.ConfigurationException;


public class LCServer {
	private ResolutionHandler rh = null;
	private CCNHandle ccn_handle = null;
	static private String path_conf_file = null;
	static private int remote_port = 0;
	static public ConcurrentSkipListSet<String> reqInFly; 
	
	
	
	public LCServer(String path_conf_file_, int remote_port_){
		//this.rh = new ResolutionHandler(path_conf_file, remote_port);
		try {
			ccn_handle = CCNHandle.open();
		} catch (ConfigurationException e) {
			System.out.println("ConfigurationException");		
			e.printStackTrace();
		} catch (IOException e) {
			System.out.println("IOException");
			e.printStackTrace();
		}
		path_conf_file=new String(path_conf_file_);
		System.out.println("PATH :" + path_conf_file);
		remote_port=remote_port_;
	}
	

	public static void main(String[] args) {

		String ccn_name = null; // ccn name to be routed
		int lport, rport;
		
		int s_ccnd_sport = 9696; // source port of the ccnd socket
		reqInFly = new ConcurrentSkipListSet<String>();
		
		if(args.length < 1 || args.length > 2){
			System.out.println("Wrong parameters number\n");
			System.out.println("i.e: java -jar lcserver.java config_file_path [nrs_port]");
			System.exit(1);
		}
		if(args.length == 2)
			rport = Integer.parseInt(args[1]);
		else
			rport = 9999;
		
		LCServer lc_server = new LCServer(args[0], rport);

		DatagramSocket serverSocket;
		try {
			serverSocket = new DatagramSocket(s_ccnd_sport);

			System.out.println("Server is listening...");
			while(true){
				byte[] data = new byte[100];
				DatagramPacket received_pack = new DatagramPacket(data, data.length);
				serverSocket.receive(received_pack);
				// just to debug, I'm printing bytes 
				//FileOutputStream fos = new FileOutputStream("debug_packet");
				//fos.write(received_pack.getData());
				//fos.close();
				
				ByteArrayInputStream bos = new ByteArrayInputStream(received_pack.getData());
				int c = 0;
				boolean flag = false;
				StringBuffer buffer = new StringBuffer();

				// very obsolete method to perform this check, probably some regular expressions based java class could do better
				while((c = bos.read())!= -1){
					char ch = (char) c;
					if(ch > '\u0021' && ch < '\u007F'){
						buffer.append((char)c);
						flag = false;
					}
					else{						
						if(!flag){
							flag= true;
							buffer.append('/');
						}
					}
				}		
				ccn_name = buffer.toString();
				ccn_name = ccn_name.substring(0, ccn_name.length()-1);
				int index = ccn_name.lastIndexOf('/');
				ccn_name = ccn_name.substring(0,index+1);
//				String name = ccn_name.replaceAll("[^(\\u0021-\\u007F)]", "..");
//				ccn_name = "";
//				String[] temp = name.split("......");
//				for(int i = 0; i < temp.length-1; i++){
//					ccn_name += "/" + temp[i];
//				}
				//System.out.println("Received string: " + ccn_name + " N.Threads "+Thread.activeCount());
				if (ccn_name.startsWith("/"))
					ccn_name=ccn_name.substring(1);
					// patch for a bug in ccnx-lc
				if (!reqInFly.contains(ccn_name)) {
					reqInFly.add(ccn_name);
					Thread nrsquery = new Thread(new NRSQuery(ccn_name, new ResolutionHandler(path_conf_file, remote_port)/*lc_server.rh*/, lc_server.ccn_handle, reqInFly));
					nrsquery.start();
				}
					
			
			}
		} catch (SocketException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		}



	}

}
