import java.io.IOException;
import java.sql.Date;
import java.util.concurrent.ConcurrentHashMap;
import java.util.concurrent.ConcurrentSkipListSet;

import org.ccnx.ccn.CCNHandle;
import org.ccnx.ccn.profiles.ccnd.FaceManager;
import org.ccnx.ccn.profiles.ccnd.PrefixRegistrationManager;
import org.ccnx.ccn.protocol.ContentName;
import org.ccnx.ccn.protocol.MalformedContentNameStringException;

public class NRSQuery implements Runnable {
	private ResolutionHandler rh = null;
	private String content_name = null;
	private String ccnPrefix = null;
	private CCNHandle ccn_handle = null;
	private static ConcurrentSkipListSet<String> reqInFly;
	private String origin_cname;

	public NRSQuery(String content_name, ResolutionHandler rh, CCNHandle ccn_handle, ConcurrentSkipListSet<String> reqInFly_){
		this.rh = rh;
		origin_cname=content_name;
		this.content_name = checkForKeys(content_name);
		this.ccn_handle = ccn_handle;
		ccnPrefix = "ccnx:/";
		reqInFly=reqInFly_;

	}


	private String checkForKeys(String content_name2) {
		int index = content_name2.indexOf("/Keys/");
		if(index != -1)
			return content_name2.substring(0, index+6);
		else
			return content_name2;
	}

	// remember to specify the flag '259' during the new route addition
	private void addRoute(String prefix_name, String conetIP, String port) {
		//FaceManager fHandle;
		try {
			if(port == null)
				port = "9695";
			// we could directly pass the prefix string as argument to the registerPrefix method, but it's better to use the contentName to check the content name is well-formed
			ContentName content = new ContentName(ContentName.fromURI(prefix_name));
			String command = "ccndc add " +prefix_name+ " udp " + conetIP + " 9695 259";
   		 	//System.out.println(command);
   		 	Process process=null;
			try {
				process = Runtime.getRuntime().exec(command);
			} catch (IOException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
   		 	try {
				int returnCode = process.waitFor();
			} catch (InterruptedException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
			
		/*	fHandle = new FaceManager(ccn_handle);
			Integer faceID = fHandle.createFace(NetworkProtocol.UDP,conetIP,new Integer(port));    	
			PrefixRegistrationManager prefixHandle = new PrefixRegistrationManager(ccn_handle);
			prefixHandle.registerPrefix(content, faceID, Integer.valueOf(259));
			
		} catch (CCNDaemonException e) {
			e.printStackTrace();*/
		} catch (MalformedContentNameStringException e) {
			e.printStackTrace();
		}
	}

	@Override
	public void run() {
		
		String ip = rh.find("/" + content_name);
		String cname = ccnPrefix + content_name;
		if(ip != null){
			//System.out.println("adding route to " + ip + " for " + cname);
			this.addRoute(cname, ip, null);
		}
		reqInFly.remove(origin_cname);
		//else
			//System.out.println("No ip found for " + cname);
	}

}
