package conet.util;


import java.io.IOException;
import java.net.DatagramPacket;
import java.net.DatagramSocket;
import java.net.InetAddress;

import hashbuilder.HashTable;
import conet.signaling.ConetSignal;
import conet.signaling.message.Register;
import conet.socket.*;
import conet.configure.*;
import edu.byu.nlp.util.TrieMap;

public class Register_management {

	public void manage(Register hostdata_reg ,TrieMap<String[][]>myMap,String ip_sender){

		ConfigureExample conf = ConfigureExample.getInstance();
		HashTable build = new HashTable(); 
		Hashbuilder load = new Hashbuilder();
		
		String[] nre_peers = conf.getParams("nre_peers");
		String[] local_bg = conf.getParams("local_bg");
		String[] remote_bg = conf.getParams("remote_bg");
		String[] nre_parents = conf.getParams("nre_parents");
		String[] netmask = conf.getParams("net_mask");
		
		try{    
			byte flag = hostdata_reg.flag;
			if (flag==1) {                                    //Flag =1 : Register JSON packet has been received from local PUBLISHER;
				String[][] list=build.publishlista(hostdata_reg,netmask);   //builds an array containing the HashTable values; 
				load.hashadd(myMap,hostdata_reg,list);
				byte server_flag= 0;   
				int distance = Integer.parseInt(hostdata_reg.distance);      //adds one hop to the previous distance;
				
				for (int j=0; j<nre_peers.length; j++){                               //sends Register message to peers;
					if (nre_peers[0] !=null){ 
						Register msgRegister = new Register(hostdata_reg.contentName,local_bg[j],server_flag,Integer.toString(distance));//sends to peers;
						String serializedClass = ConetSignal.serialize(msgRegister);
						transfer(nre_peers[j],9999,serializedClass);}
					else {System.out.println("peer servers are not available!");}

				}   for (int j=0; j< nre_parents.length; j++){                               //sends Register message to peers and parents;
					if (nre_parents[0] !=null){ 
						Register msgRegister = new Register(hostdata_reg.contentName,local_bg[j],server_flag,Integer.toString(distance));//sends to peers;
						String serializedClass = ConetSignal.serialize(msgRegister);
						transfer(nre_parents[j],9999,serializedClass);}
					else {System.out.println("parent servers are not available!");}                                                  

				}} 

			else if(flag==0) {                                //Flag = 0 : Register JSON packet has been received from a peer server;
				for (int i=0; i<remote_bg.length; i++){
					if (remote_bg[i] !=null && remote_bg[i].equals(hostdata_reg.address)){     //searches for remote_bg in the conf.file;
						String[][] list = build.serverlista(hostdata_reg, local_bg,netmask,i);
						load.hashadd(myMap,hostdata_reg, list);}}
				byte server_flag =0;    
				int distance = Integer.parseInt(hostdata_reg.distance) +1;
				for (int j=0; j<nre_peers.length; j++){
					if (nre_peers[0] !=null){
						if (!nre_peers[j].equals(ip_sender)){                  //sends Register message to peers except for the NRS it just had it from;
							Register msgRegister = new Register(hostdata_reg.contentName,local_bg[j],server_flag,Integer.toString(distance));
							String serializedClass = ConetSignal.serialize(msgRegister);
							transfer(nre_peers[j],9999,serializedClass);
						}
					}
					else {System.out.println("Peer servers not available!");}}

				for (int j=0; j<nre_parents.length; j++){                                       //sends Register message to parents;
					if (nre_parents[0] !=null){ 
						Register msgRegister = new Register(hostdata_reg.contentName,local_bg[j],server_flag,Integer.toString(distance));//sends to peers;
						String serializedClass = ConetSignal.serialize(msgRegister);
						transfer(nre_parents[j],9999,serializedClass);}
					else {System.out.println("parent servers are not available!");}}


			}
		}
		catch(IOException e){e.printStackTrace();}
	}
	

	public void transfer(String host, int port, String data) throws IOException
	{	
		byte[] sendData = new byte[1024];
		DatagramSocket clientSocket = new DatagramSocket();
		sendData = data.getBytes();
		InetAddress ip = InetAddress.getByName(host);
		String ip_print=ip.getHostAddress();
		DatagramPacket sendPacket = new DatagramPacket(sendData,sendData.length,ip,port);
		clientSocket.send(sendPacket);
		System.out.println("Sending to: "+ip_print);

	}
	
	
}


