#include <sys/time.h>
#include <stdlib.h>
#include <time.h>
#include <stdio.h>
#include <stdint.h>
#include <math.h>             // Needed for log()
#include <assert.h>             // Needed for assert() macro
#include <pthread.h>
#include <string.h>
#define  FALSE          0       // Boolean false
#define  TRUE           1       // Boolean true
#define MAX_THREADS     380
#define NUM_TOT_CONTENT 1900

int      zipf(double alpha, int n);  // Returns a Zipf random variable
double   rand_val(int seed);         // Jain's RNG
double expon(double x);
void *ccn_func( void *ptr );
void *cancel_thread();

uint32_t
get_time()
{
	struct timeval  tv;
	struct timezone tz;
	struct tm      *tm;
	uint32_t         start;

	gettimeofday(&tv, &tz);
	tm = localtime(&tv.tv_sec);

//	printf("TIMESTAMP-START\t  %d:%02d:%02d:%d (~%d ms)\n", tm->tm_hour,
//	       tm->tm_min, tm->tm_sec, tv.tv_usec,
//	       tm->tm_hour * 3600 * 1000 + tm->tm_min * 60 * 1000 +
//	       tm->tm_sec * 1000 + tv.tv_usec / 1000);

	start = tm->tm_hour * 3600 * 1000 + tm->tm_min * 60 * 1000 +
		tm->tm_sec * 1000 + tv.tv_usec / 1000;

	return (start);

}


pthread_t thread[10000];
uint32_t thread_start_times[10000];
uint32_t thread_status[10000];//0 not init, 1 executing, 2 exited
FILE *file;

struct thread_args
 {
    char req_msg[250];
    int num;
    int n_seq;
};

int num_req_content;

int main(int argc ,const char* argv[]) {

	int rc;
	int n_req;
	int seed;
	int start;
	int index_thread_status;
	int stop_simulation;
	uint32_t time_last=0;
	uint32_t now;
	uint32_t next_arrival=0;	
	uint32_t mean_exp;

	FILE *i2n=fopen("index2name.txt","r");
	if (argc < 4){
                printf("too few arguments---\n enter thr total number of content to request\n seed for number generator\n mean value of exp distribution\n");
                exit(1);
        }

        if (argc > 4){

                printf("too many arguments\n");
     		exit(1);
        }
	start =0;


	pthread_attr_t attr;
	pthread_attr_init(&attr);
   	pthread_attr_setdetachstate(&attr, PTHREAD_CREATE_JOINABLE);

	memset(thread_start_times,0x00,10000);
	memset(thread_status,0x00,10000);
	num_req_content = atoi(argv[1]);
	seed = atoi(argv[2]);
	mean_exp = atoi(argv[3]);
	rand_val(seed);
		

	n_req=1;

	file = fopen("./time.txt","w");
	fclose(file);
	file = fopen("./time.txt","a+"); /* apend file (add text to */
	//printf("total number of req:%d\n",num_req_content);
	int zipf_ext;

	char content[250]={0x0};
  	int numline = 1;

	while(n_req <= num_req_content){
	
		
		now = get_time();
	//	printf("now:%d\n",now);
	//	printf("last:%d\n",time_last);
		if(now - time_last >= next_arrival){
			struct thread_args *Structthread =(struct thread_args*) malloc(sizeof(struct thread_args));
	
			time_last=get_time();
			zipf_ext=zipf(0.8,NUM_TOT_CONTENT);
		//	printf("extration:%d\n",zipf_ext);
			while(i2n != NULL && fgets(content, sizeof(content),i2n) !=NULL)
 			{	
    				if(numline == zipf_ext) {
      		//			printf("found, row:%d content:%s", numline, content);
					fclose(i2n);
					i2n=fopen("index2name.txt","r");
					break;
    				}
    			numline++;
  			}
			
			
			//char *content_name = malloc( strlen(content) -2);
			//memset(content_name,0x00,strlen(content) -2);
			//memcpy(content_name, content, strlen(content)-2);
			char *content_name = strtok (content," ");
		//	printf("issue request for content:%s %d\n",content_name,strlen(content_name));
			sprintf (Structthread->req_msg,"ccncatchunks2 -s -p 4 %s > /dev/null",content_name);
			//sprintf (Structthread->req_msg,"ccncatchunks2 -s -p 4 ccnx:/pippo1 > /dev/null");
			//Structthread->num = n_req+start;
			Structthread->num = zipf_ext;
	      		Structthread->n_seq = n_req-1; 

			rc = pthread_create( &thread[n_req], &attr, ccn_func, (void*) Structthread);
	      		if (rc) {
              			printf("ERROR; return code from pthread_create() is %d\n", rc);
				thread_status[n_req-1]=3;
              		}	
	 
	      		else{
				thread_start_times[n_req-1]=get_time();
				thread_status[n_req-1]=1;
				n_req++;
			}

		//	printf("n_req:%d\n",n_req);
			next_arrival = (uint32_t) (expon((double)(mean_exp))*1000);
	//		printf("next arrival:%d\n",next_arrival);
	}
	else{
	  usleep(100000);
	}
	numline=1;
	memset(content,0x00,256);
	
}
//	printf("exit while\n");
	stop_simulation =0;
	while(stop_simulation == 0){
		stop_simulation = 1;
	//	printf("trad status: ");
		for(index_thread_status = 0; index_thread_status < num_req_content ; index_thread_status ++){	
			//printf("%d ",thread_status[index_thread_status]);	
			if (thread_status[index_thread_status]==1){
				stop_simulation = 0;
				sleep(5);
				break;
			}
		}
//	printf("\n");
//	printf("whileing\n");	

	}
	return(1);	
}

void *ccn_func( void *ptr)
	{
	      int num;
	      int seq;
	      uint32_t time_start;
	      uint32_t time_stop;
	      char *message;
	      struct thread_args *args = (struct thread_args *)ptr;
	      int res=256;
	   
	      message = args->req_msg;
	      num = args->num;
	      seq = args->n_seq;
	      pthread_detach( thread[seq+1]);

	      time_start = get_time();
	      while(res==256){
		res = system(message);
	//	printf("res:%d\n",res);
		if(res==256){
			usleep(1500000);
	//		count_retry++;
			printf("RETRY: %d \n",num);
		}
	      }
	      time_stop = get_time();

	      fprintf(file,"%d	%d	%d	%d	%d\n",seq,num,time_stop-time_start,time_start,time_stop);
	      fflush(file);
	      thread_status[seq]=2;
	      return(NULL);
	}

void *cancel_thread(){

	int index;
	int count;
	while(thread_start_times[num_req_content-1]==0){
		index=0;
		count =0;
		while(thread_status[index]!=0){	
			if(thread_start_times[index]!=0 &&
		   		get_time()-thread_start_times[index]>30*1000 &&
		    		thread_status[index]==1){

					pthread_cancel(thread[index]);
					printf("start:%d,now:%d CANCEL\n",thread_start_times[index],get_time());
					thread_status[index]=2;
			}
			else if (thread_status[index]==1){
				count ++;	
			}
			index++;
			//printf("ATTIVI: %d\n",count);
		}
	sleep(1);
	}
	sleep(10);
	return(NULL);
}

//===========================================================================
//=  Function to generate Zipf (power law) distributed random variables     =
//=    - Input: alpha and N                                                 =
//=    - Output: Returns with Zipf distributed random variable              =
//===========================================================================
int zipf(double alpha, int n)
{
  static int first = TRUE;      // Static first time flag
  static double c = 0;          // Normalization constant
  double z;                     // Uniform random number (0 < z < 1)
  double sum_prob;              // Sum of probabilities
  double zipf_value;            // Computed exponential value to be returned
  int    i;                     // Loop counter

  // Compute normalization constant on first call only
  if (first == TRUE)
  {
    for (i=1; i<=n; i++)
      c = c + (1.0 / pow((double) i, alpha));
    c = 1.0 / c;
    first = FALSE;
  }

  // Pull a uniform random number (0 < z < 1)
  do
  {
    z = rand_val(0);
  }
  while ((z == 0) || (z == 1));

  // Map z to the value
  sum_prob = 0;
  for (i=1; i<=n; i++)
  {
    sum_prob = sum_prob + c / pow((double) i, alpha);
    if (sum_prob >= z)
    {
      zipf_value = i;
      break;
    }
  }

  // Assert that zipf_value is between 1 and N
  assert((zipf_value >=1) && (zipf_value <= n));

  return(zipf_value);
}

//=========================================================================
//= Multiplicative LCG for generating uniform(0.0, 1.0) random numbers    =
//=   - x_n = 7^5*x_(n-1)mod(2^31 - 1)                                    =
//=   - With x seeded to 1 the 10000th x value should be 1043618065       =
//=   - From R. Jain, "The Art of Computer Systems Performance Analysis," =
//=     John Wiley & Sons, 1991. (Page 443, Figure 26.2)                  =
//=========================================================================
double rand_val(int seed)
{
  const long  a =      16807;  // Multiplier
  const long  m = 2147483647;  // Modulus
  const long  q =     127773;  // m div a
  const long  r =       2836;  // m mod a
  static long x;               // Random int value
  long        x_div_q;         // x divided by q
  long        x_mod_q;         // x modulo q
  long        x_new;           // New x value

  // Set the seed if argument is non-zero and then return zero
  if (seed > 0)
  {
    x = seed;
    return(0.0);
  }

  // RNG using integer arithmetic
  x_div_q = x / q;
  x_mod_q = x % q;
  x_new = (a * x_mod_q) - (r * x_div_q);
  if (x_new > 0)
    x = x_new;
  else
    x = x_new + m;

  // Return a random value between 0.0 and 1.0
  return((double) x / m);
}


//===========================================================================
//=  Function to generate exponentially distributed random variables        =
//=    - Input:  Mean value of distribution                                 =
//=    - Output: Returns with exponentially distributed random variable     =
//===========================================================================
double expon(double x)
{
  double z;                     // Uniform random number (0 < z < 1)
  double exp_value;             // Computed exponential value to be returned

  // Pull a uniform random number (0 < z < 1)
  do
  {
    z = rand_val(0);
  }
  while ((z == 0) || (z == 1));

  // Compute exponential random variable using inversion method
  exp_value = -x * log(z);

  return(exp_value);
}
